/* package com.rc.mq; */
import com.ibm.mq.*;
public class MQClient
{

 private String qmgrName = null;
 private MQQueueManager qMgr = null;
 private MQQueue q = null;


 public static void main(String args[])
 {
  try
  {
   String qMgrName = args[0];
   String qName = args[1];
   for(int i = 2; i < 100; i++)
   {
    MQClient mh = new MQClient();
    mh.setQM(qMgrName);
    String msg = new java.util.Date().toString();
    System.out.println("Putting message : <" + msg + "> of length " + msg.length());
    mh.put(qName, msg);
   }

/*   System.out.println("Retrieving Messages .... ");
   while(true)
   {
    MQClient mh = new MQClient();
    mh.setQM(qMgrName);
    String msg = mh.get(qName, null);
    System.out.println("Retrieved Message : " + msg);
   } */
  }
  catch(Exception e)
  {
   e.printStackTrace();
  }
 }
 public void setQM(String qmName) throws Exception
 {
  qmgrName = qmName;
  try
  {
        qMgr = new MQQueueManager(qmgrName);
  }
  catch(MQException e)
  {
   throw new Exception(
     " Unable to connect to Queue Manager : " + qmgrName +
     " Exception is : " + e.getMessage());
  }


 }

 private void cleanup()
 {
  if(q != null)
  {
   try{ q.close(); } catch(MQException e) {}
  }

  if(qMgr != null)
  {
   try{ qMgr.disconnect(); } catch(MQException e) {}
  }
 }


 private MQQueue openQueue(String qName) throws Exception
 {
      int openOptions = MQC.MQOO_INPUT_AS_Q_DEF |
                        MQC.MQOO_OUTPUT ;

      // Now specify the queue that we wish to open, and the open options...
       try
       {

            q = qMgr.accessQueue(qName, openOptions, null, null, null);
            return q;
       }
  catch(MQException e)
  {
   throw new Exception(
     " Unable to open Queue : " + qName +
     " Exception is : " + e.getMessage());
  }

 }


 public String  put(String qName, String msg) throws Exception
 {
  MQQueue qObj = null;
  try
  {
   qObj = openQueue(qName);
   MQMessage mqMsg = new MQMessage();
   MQPutMessageOptions pmo = new MQPutMessageOptions();
   mqMsg.format = MQC.MQFMT_STRING;
   mqMsg.writeString(msg);
   qObj.put(mqMsg,pmo);
/*  MQMessage mqMsg1 = new MQMessage();
   MQPutMessageOptions pmo1 = new MQPutMessageOptions();
   mqMsg1.writeUTF(msg);
   qObj.put(mqMsg1,pmo1);
   return (new String(mqMsg.correlationId));*/
   String msgString = new String(mqMsg.messageId);
   System.out.println("Message Id as Bytes : " + mqMsg.messageId);
   System.out.println("Message Id Length " + mqMsg.messageId.length);
   System.out.println("Message Id as String : " + msgString);
   System.out.println("Correlation Id : " + mqMsg.correlationId);
//   return (mqMsg.messageId);
   return (msgString);
  }
  catch(MQException e)
  {
   throw new Exception("Caught an exception while putting message to Queue. " +
            e.toString());
  }
  catch(java.io.IOException e)
  {
   throw new Exception("Caught an exception while preparing to write the message . " +
            e.toString());
  }
  catch(Exception e)
  {
   throw e;
  }
  finally
  {
   cleanup();
  }

 }

 public String get(String qName, String correlId) throws Exception
 {
  MQQueue qObj = null;
  try
  {
   qObj = openQueue(qName);
   MQMessage mqMsg = new MQMessage();
   if(correlId == null)
   {
    qObj.get(mqMsg);
   }
   else
   {
    throw new Exception("Retrieval of message on the basis of correlationId is not yet implemented");
   }
    String msg = mqMsg.readUTF();
   return msg;
  }
  catch(MQException e)
  {
   throw new Exception("Caught an exception while getting message to Queue. " +
            e.toString());
  }
  catch(java.io.IOException e)
  {
   throw new Exception("Caught an exception while reading data from the message . " +
            e.toString());
  }
  catch(Exception e)
  {
   throw e;
  }
  finally
  {
   cleanup();
  }
 }
}

